package com.fp.persistence.pgeneral.transf;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.sql.Date;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.SQLQuery;
import org.hibernate.Session;

import com.fp.dto.hb.Cache;
import com.fp.dto.hb.HibernateBean;

/** Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENETRANSFERDETAIL */
@Entity(name = "TgeneTransferDetail")
@Table(name = "TGENETRANSFERDETAIL")
public class TgeneTransferDetail extends com.fp.dto.AbstractDataTransport
		implements
			Serializable,HibernateBean,Cloneable,Cache {
	/**
	 * HashCode asociado con la Instancia
	 */
	@Transient
	private int hashValue = 0;
	/**
	 * Version de la Clase
	 */
	private static final long serialVersionUID = 1L;
	/**
	 * Clave primaria de la Entidad TgeneTransferDetail
	 */
	@EmbeddedId
	private TgeneTransferDetailKey pk;
	@Column(name = "TRANSACTIONMODULE", nullable = true)
	/**
	 * Modulo al que pertence la transaccion
	 */
	private String transactionmodule;

	@Column(name = "TRANSACTIONCODE", nullable = true)
	/**
	 * Codigo de transaccion dentro del modulo
	 */
	private Integer transactioncode;

	@Column(name = "TRANSACTIONVERSION", nullable = true)
	/**
	 * Version de transaccion
	 */
	private Integer transactionversion;

	@Column(name = "DEBITITEM", nullable = true)
	/**
	 * Codigo de rubro debito.
	 */
	private Integer debititem;

	@Column(name = "CREDITITEM", nullable = true)
	/**
	 * Codigo de rubro credito.
	 */
	private Integer credititem;

	@Column(name = "REVERSEDEBITITEM", nullable = true)
	/**
	 * Codigo de rubro asociado al debito de reverso.
	 */
	private Integer reversedebititem;

	@Column(name = "REVERSECREDITITEM", nullable = true)
	/**
	 * Codigo de rubro asociado al credito de reverso.
	 */
	private Integer reversecredititem;

	/** Contructor por defecto */
	public TgeneTransferDetail() {
	}
	/**
	 * Contructor de TgeneTransferDetail
	 * 
	 * @param pPk Clave Primaria del entity
	 */
	public TgeneTransferDetail(TgeneTransferDetailKey pPk) {
		this();
		pk = pPk;
	}
	/**
	 * Metodo que entrega datos de la tabla dada la clave primaria.
	 * 
	 * @param pEntityManager referencia de la session a obtener datos del bean.
	 * @param pKey Caleve primaria del bean.
	 * @return TgeneTransferDetail
	 */
	public static TgeneTransferDetail find(EntityManager pEntityManager, TgeneTransferDetailKey pKey) throws Exception {
		TgeneTransferDetail obj = pEntityManager.find(TgeneTransferDetail.class, pKey);
		return obj;
	}
	/**
	 * Entrega la Clave primaria de TgeneTransferDetail
	 * 
	 * @return El objeto que referencia a la Clave primaria de TgeneTransferDetail
	 */
	public TgeneTransferDetailKey getPk() {
		return pk;
	}
	/**
	 * Fija un nuevo valor a la Clave primaria de TgeneTransferDetail
	 * 
	 * @param pPk El objeto que referencia a la nueva Clave primaria de TgeneTransferDetail
	 */
	public void setPk(TgeneTransferDetailKey pPk) {
		pk = pPk;
	}
	/**
	 * Obtiene el valor de transactionmodule
	 * 
	 * @return valor de transactionmodule
	 */
	public String getTransactionmodule() {
		return transactionmodule;
	}
	/**
	 * Fija el valor de transactionmodule
	 * 
	 * @param pTransactionmodule nuevo Valor de transactionmodule
	 */
	public void setTransactionmodule(String pTransactionmodule) {
		transactionmodule = pTransactionmodule;
	}

	/**
	 * Obtiene el valor de transactioncode
	 * 
	 * @return valor de transactioncode
	 */
	public Integer getTransactioncode() {
		return transactioncode;
	}
	/**
	 * Fija el valor de transactioncode
	 * 
	 * @param pTransactioncode nuevo Valor de transactioncode
	 */
	public void setTransactioncode(Integer pTransactioncode) {
		transactioncode = pTransactioncode;
	}

	/**
	 * Obtiene el valor de transactionversion
	 * 
	 * @return valor de transactionversion
	 */
	public Integer getTransactionversion() {
		return transactionversion;
	}
	/**
	 * Fija el valor de transactionversion
	 * 
	 * @param pTransactionversion nuevo Valor de transactionversion
	 */
	public void setTransactionversion(Integer pTransactionversion) {
		transactionversion = pTransactionversion;
	}

	/**
	 * Obtiene el valor de debititem
	 * 
	 * @return valor de debititem
	 */
	public Integer getDebititem() {
		return debititem;
	}
	/**
	 * Fija el valor de debititem
	 * 
	 * @param pDebititem nuevo Valor de debititem
	 */
	public void setDebititem(Integer pDebititem) {
		debititem = pDebititem;
	}

	/**
	 * Obtiene el valor de credititem
	 * 
	 * @return valor de credititem
	 */
	public Integer getCredititem() {
		return credititem;
	}
	/**
	 * Fija el valor de credititem
	 * 
	 * @param pCredititem nuevo Valor de credititem
	 */
	public void setCredititem(Integer pCredititem) {
		credititem = pCredititem;
	}

	/**
	 * Obtiene el valor de reversedebititem
	 * 
	 * @return valor de reversedebititem
	 */
	public Integer getReversedebititem() {
		return reversedebititem;
	}
	/**
	 * Fija el valor de reversedebititem
	 * 
	 * @param pReversedebititem nuevo Valor de reversedebititem
	 */
	public void setReversedebititem(Integer pReversedebititem) {
		reversedebititem = pReversedebititem;
	}

	/**
	 * Obtiene el valor de reversecredititem
	 * 
	 * @return valor de reversecredititem
	 */
	public Integer getReversecredititem() {
		return reversecredititem;
	}
	/**
	 * Fija el valor de reversecredititem
	 * 
	 * @param pReversecredititem nuevo Valor de reversecredititem
	 */
	public void setReversecredititem(Integer pReversecredititem) {
		reversecredititem = pReversecredititem;
	}

	public boolean equals(Object rhs) {
		if (rhs == null)
			return false;
		if (!(rhs instanceof TgeneTransferDetail))
			return false;
		TgeneTransferDetail that = (TgeneTransferDetail) rhs;
		if (this.getPk() == null || that.getPk() == null)
			return false;
		return (this.getPk().equals(that.getPk()));
	}
	/**
	 * Implementación del metodo hashCode de la la entidad TgeneTransferDetail
	 * 
	 * @return el hashCode la instancia
	 */
	public int hashCode() {
		if (this.hashValue == 0) {
			int result = 17;
			if (this.getPk() == null) {
				result = super.hashCode();
			} else {
				result = this.getPk().hashCode();
			}
			this.hashValue = result;
		}
		return this.hashValue;
	}
	/** Implementación toString */
	public String toString() {
		Field[] fs = this.getClass().getDeclaredFields();
		String data = "";
		for (Field f : fs) {
			try {
				String name = f.getName();
				if (f.getType().getName().compareTo("java.util.Set") == 0)
					continue;
				if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0)
					continue;
				data += name + "=" + f.get(this) + ";";
			} catch (Exception e) {
				continue;
			}
		}
		if (data.compareTo("") == 0) {
			data = super.toString();
		}
		return data;
	}
	/** Implementación de la creación de un bean en blanco TgeneTransferDetail */
	public Object createInstance() {
		TgeneTransferDetail instance = new TgeneTransferDetail();
		instance.setPk(new TgeneTransferDetailKey());
		return instance;
	}
	/**
	 * Clona la entidad TgeneTransferDetail
	 * 
	 * @see com.fp.dto.hb.HibernateBean#cloneMe()
	 */
	public Object cloneMe() throws CloneNotSupportedException {
		TgeneTransferDetail p = (TgeneTransferDetail) this.clone();
		p.setPk((TgeneTransferDetailKey) this.pk.cloneMe());
		return p;
	}
	
	//Metodos manuales.
    /**sentencia que elimina tgenetellertransferdetail*/
    private static final String DEL_TRANSF_DETAIL =
            " delete from TGENETELLERTRANSFERDETAIL t "
            + " where t.WORKINGDATE = :workingdate "
            + " and t.USERCODE = :usercode "
            + " and t.TRANSFERNUMBER = :transfernumber";
    /**
     * Elimina un registro de la tabla para el usuario, fecha de trabajo y numero de transferencia.
     * @param pEntityManager  Referencia la session de la base de datos.
     * @param pWorkingdate  Fecha de trabajo.
     * @param pUser  Codigo de usuario.
     * @param pTransfernumber  Numero de transferencia. 
     * @throws Exception
     */
    public static void delete(EntityManager pEntityManager,Date pWorkingdate,String pUser,Integer pTransfernumber) throws Exception {
        //Elimina tgenetellertransferdetail
    	Session s =  (Session)pEntityManager.getDelegate();
        SQLQuery sqldet = s.createSQLQuery(DEL_TRANSF_DETAIL);
        sqldet.setDate("workingdate", pWorkingdate);
        sqldet.setString("usercode", pUser);
        sqldet.setInteger("transfernumber", pTransfernumber);
        sqldet.executeUpdate();
    }
}
